#!/bin/bash

set -e

SDK_VERSION=$(xcrun --sdk iphoneos --show-sdk-version)
ARCHS=("arm64" "arm64e")

for ARCH in "${ARCHS[@]}"; do
    SYSROOT=$(xcrun --sdk iphoneos --show-sdk-path)
    PREFIX="$(pwd)/build/ios-${ARCH}"

    export CC="$(xcrun --sdk iphoneos --find clang)"
    export CXX="$(xcrun --sdk iphoneos --find clang++)"
    export CPP="$(xcrun --sdk iphoneos --find cpp)"
    export LD="$(xcrun --sdk iphoneos --find ld)"
    export AR="$(xcrun --sdk iphoneos --find ar)"
    export AS="$(xcrun --sdk iphoneos --find as)"
    export NM="$(xcrun --sdk iphoneos --find nm)"
    export RANLIB="$(xcrun --sdk iphoneos --find ranlib)"
    export STRIP="$(xcrun --sdk iphoneos --find strip)"
    export LDFLAGS="-arch ${ARCH} -isysroot ${SYSROOT}"
    export CFLAGS="-arch ${ARCH} -isysroot ${SYSROOT} -mios-version-min=9.0"

    xmake f -p iphoneos -a ${ARCH} --sdk=${SDK_VERSION}
    xmake
    mkdir -p "${PREFIX}/bin"
    cp build/ios/${ARCH}/release/zsign "${PREFIX}/bin/"
done
